function getContext(context, name) {
	while (context && !context.subModules.hasOwnProperty(name))
		context = context.superModule;
	return context;
}

function findDirect(context, path) {
	for (var t = 0, l = path.length; t < l; ++t) {
		if (!context.subModules.hasOwnProperty(path[t]))
			return null;
		context = context.subModules[path[t]];
	}
	
	return context;
}

function find(context, path) {
	context = getContext(context, path[0]);
	return context ? findDirect(context, path) : null;;
};

exports.find = function (context, path) {
	path = path.split(/\./);
	if (path.length < 1)
		throw new Error();
	return find(context, path);
};
