var find = require('./find').find;
var warn = require('./warn').warn;

function unshiftModule(module, list) {
	var indexOf = list.indexOf(module);
	indexOf === -1 || list.splice(indexOf, 1);
	list.unshift(module);
}

function resolve(context, list) {
	unshiftModule(context, list);
	
	var dependencies = context.yamlData.depends;
	if (dependencies) {
		for (var t = dependencies.length; t--;) {
			var module = find(context, dependencies[t]);
			if (module) {
				resolve(module, list);
			} else {
				warn(dependencies[t], 'Module not found.');
			}
		}
	}
};

exports.resolve = function (context, callback) {
	var list = [];
	resolve(context, list);
	for (var t = 0, l = list.length; t < l; ++t) {
		callback(list[t]);
	}
};
